﻿Partial Public Class Page
    Inherits UserControl

    Public Sub New()
        InitializeComponent()
    End Sub
 Dim tabMarques() As Rectangle
 Dim PosPrec As Point
 Dim nMarqueDéplacée As Integer = -1 ' quelle marque est déplacée
 Private Sub Canvas_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
  tabMarques = New Rectangle(3) {}
  tabMarques(0) = M0
  tabMarques(1) = M1
  tabMarques(2) = M2
  tabMarques(3) = M3
  For i As Integer = 0 To tabMarques.Length - 1
   AddHandler tabMarques(i).MouseLeftButtonDown, AddressOf Marques_MouseLeftButtonDown
   AddHandler tabMarques(i).MouseMove, AddressOf Marques_MouseMove
   AddHandler tabMarques(i).MouseLeftButtonUp, AddressOf Marques_MouseLeftButtonUp
  Next i
  DisplayParameters()
 End Sub
 Private Sub Marques_MouseLeftButtonDown(ByVal sender As Object, ByVal e As MouseEventArgs)
  Dim r As Rectangle = TryCast(sender, Rectangle)
  If r IsNot Nothing Then
   Dim p As Point = e.GetPosition(Me)
   Dim s As String = r.Name.Substring(1)
   Dim nMarque As Integer = Int32.Parse(s)
   nMarqueDéplacée = nMarque
   PosPrec = p
   tabMarques(nMarque).CaptureMouse()
  End If
 End Sub
 Private Sub Marques_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs)
  Dim r As Rectangle = TryCast(sender, Rectangle)
  If r IsNot Nothing Then
   ' one f our 4 marks, which one ?
   Dim s As String = r.Name.Substring(1)
   Dim nMark As Integer = Int32.Parse(s)
   If nMarqueDéplacée = nMark Then
    Dim deltaX, deltaY As Double
    Dim p As Point = e.GetPosition(Me)
    deltaX = p.X - PosPrec.X
    deltaY = p.Y - PosPrec.Y
    Dim X As Double = CDbl(tabMarques(nMark).GetValue(Canvas.LeftProperty))
    Dim Y As Double = CDbl(tabMarques(nMark).GetValue(Canvas.TopProperty))
    tabMarques(nMark).SetValue(Canvas.LeftProperty, X + deltaX)
    tabMarques(nMark).SetValue(Canvas.TopProperty, Y + deltaY)
    PosPrec = p
    ' create the updated Bezier curve
    Figs.Segments.Clear()
    Dim bs As New BezierSegment()
    Dim tP(3) As Point
    For i As Integer = 0 To tP.Length - 1
     tP(i).X = CDbl(tabMarques(i).GetValue(Canvas.LeftProperty)) + 5
     tP(i).Y = CDbl(tabMarques(i).GetValue(Canvas.TopProperty)) + 5
    Next i
    bs.Point1 = tP(1)
    bs.Point2 = tP(2)
    bs.Point3 = tP(3)
    Figs.StartPoint = tP(0)
    Figs.Segments.Add(bs)
    DisplayParameters()
   End If
  End If
 End Sub

 Private Sub Marques_MouseLeftButtonUp(ByVal sender As Object, ByVal e As MouseEventArgs)
  Dim r As Rectangle = TryCast(sender, Rectangle)
  If r IsNot Nothing Then
   ' quelle marque ?
   Dim s As String = r.Name.Substring(1)
   Dim nMark As Integer = Int32.Parse(s)
   nMarqueDéplacée = -1
   tabMarques(nMark).ReleaseMouseCapture()
  End If
 End Sub

 Private Sub DisplayParameters()
  Dim tP(3) As Point
  For i As Integer = 0 To tP.Length - 1
   tP(i).X = CDbl(tabMarques(i).GetValue(Canvas.LeftProperty)) + 5
   tP(i).Y = CDbl(tabMarques(i).GetValue(Canvas.TopProperty)) + 5
  Next i
  tbStPt.Text = tP(0).X & " - " & tP(0).Y
  tbEndPt.Text = tP(3).X & " - " & tP(3).Y
  tbCtrlPt1.Text = tP(1).X & " - " & tP(1).Y
  tbCtrlPt2.Text = tP(2).X & " - " & tP(2).Y
 End Sub
End Class